#!/bin/sh

if [ -x /usr/bin/NOSApp ]; then
  APP_NAME=$(basename $(readlink -f /usr/bin/NOSApp))
else
  APP_NAME=NOSApp
fi

if [ "$2" = "$APP_NAME" -o "$2" = ecdis-thor -o "$2" = KiwiApp -o "$2" = IndigoApp -o "$2" = MercuryBlackBoxApp ]
then
  FBDEV=/dev/fb0
  if [ -e /dev/fb_primary ]; then
    FBDEV=/dev/fb_primary
  fi
  FBn=$(printf "fb%d" 0x$(stat -c %T $(readlink -f $FBDEV)))

  YRES=`sed -ne 's/.*x\([0-9]\+\).*/\1/p' /sys/class/graphics/$FBn/mode`
  if [ -z $YRES ]; then
    YRES=`sed -ne 's/.*,\([0-9]\+\).*/\1/p' /sys/class/graphics/$FBn/virtual_size`
    YRES=$(($YRES/2))
  fi

  STRIDE=`cat /sys/class/graphics/$FBn/stride`

  # Grab an image of the screen at the moment the crash happened.
  #   IndigoApp uses triple buffering, so the display might be panned
  #   Figure this out so we capture right piece of screen
  YPAN=$(cut -d , -f 2 /sys/class/graphics/$FBn/pan)
  dd if=$FBDEV of=/tmp/crash-screen-grab.raw bs=$STRIDE skip=$YPAN count=$YRES

  # Return pan to 0,0 so bitmap display goes to right place
  echo 0,0 > /sys/class/graphics/$FBn/pan

  # clear the screen
  dd if=/dev/zero of=$FBDEV bs=$STRIDE count=$YRES

  if [ "$1" = "start" ]; then
    # put a bitmap on the screen to tell the user they are screwed
    BMPDX=500 # x-res * 2
    BMPDY=65
    BMPSTRIDE=125 # x-res * 2 / 32

    ( LINE=0
      FBSEEK=$((($YRES+$BMPDY)/2*$STRIDE+($STRIDE-$BMPDX)/2-1))
      dd of=/dev/null bs=70 count=1 # dump the bmp header. The header
      while [ $LINE -lt $BMPDY ]; do
        dd of=$FBDEV bs=4 seek=$(($FBSEEK/4)) count=$BMPSTRIDE
        FBSEEK=$(($FBSEEK-$STRIDE))
        LINE=$(($LINE+1))
      done
    ) </usr/share/crash.bmp 2>/dev/null
  fi
fi

